var db;

function fnInitLocal() {
    db = api.require('db');
};

var DATABASE = 'db_ambm_dianzhu';

function fnOpenDatabase() {
    fnInitLocal();
    db.openDatabase({
        name: DATABASE
    }, function(ret, err) {
        fnCreatePushMsg(function(ret, err) {
            fnCreatePushMsgIndex();
        });

        fnCreateHistory(function() {
            fnCreateHistoryIndex();
        });

        fnCreateFavorite(function() {
            fnCreateFavoriteIndex();
        });
    });
};

var PUSH_MSG = 'table_pushmsg';

function fnCreatePushMsg(callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'CREATE TABLE ' + PUSH_MSG + '(id INTEGER PRIMARY KEY, msgId VARCHAR(200), actionType VARCHAR(200),  title VARCHAR(300), content VARCHAR(500), customContent VARCHAR(500), status VARCHAR(50), createTime DATETIME)'
    }, callback);
};

function fnCreatePushMsgIndex(callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'CREATE UNIQUE INDEX INDEX_' + PUSH_MSG + '_msgId ON ' + PUSH_MSG + '(msgId)'
    }, callback);
};

function fnInsertPushMsg(msgId, actionType, title, content, customContent, callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'REPLACE INTO ' + PUSH_MSG + '(msgId, actionType, title, content, customContent, status, createTime) VALUES(\'' + msgId + '\', \'' + actionType + '\', \'' + title + '\', \'' + content + '\', \'' + customContent + '\', \'unread\', DATETIME(\'now\', \'localtime\'))'
    }, callback);
};

function fnSelectPushMsg(type, page, callback) {
    db.selectSql({
        name: DATABASE,
        sql: 'SELECT * FROM ' + PUSH_MSG + ' ORDER BY createTime DESC limit 20 offset ' + (page-1)*20
        //sql : 'SELECT * FROM ' + PUSH_MSG + ''
    }, callback);
};

function fnGetPushMsgRecord(id, callback) {
    db.selectSql({
        name: DATABASE,
        sql: 'SELECT * FROM ' + PUSH_MSG + ' WHERE id=' + id
    }, callback);
};


function fnUpdatePushMsgRead(id, callback) {
    db.selectSql({
        name: DATABASE,
        sql: 'UPDATE ' + PUSH_MSG + ' SET status=\'read\' WHERE id=' + id
    }, callback);
};

var HISTORY = 'table_history';

function fnCreateHistory(callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'CREATE TABLE ' + HISTORY + '(id INTEGER PRIMARY KEY, teamId VARCHAR(64), createTime DATETIME)'
    }, callback);
};

function fnCreateHistoryIndex(callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'CREATE UNIQUE INDEX INDEX_' + HISTORY + '_teamId ON ' + HISTORY + '(teamId)'
    }, callback);
};

function fnInsertHistory(shopId, callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'REPLACE INTO ' + HISTORY + '(teamId, createTime) VALUES("' + shopId + '", DATETIME("now"))'
    }, callback);
};

function fnSelectHistory(callback) {
    db.selectSql({
        name: DATABASE,
        sql: 'SELECT id,teamId,createTime FROM ' + HISTORY + ' ORDER BY createTime'
    }, callback);
};

var FAVORITE = 'table_favorite';

function fnCreateFavorite(callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'CREATE TABLE ' + FAVORITE + '(id INTEGER PRIMARY KEY, shopId VARCHAR(64))'
    }, callback);
};

function fnCreateFavoriteIndex(callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'CREATE UNIQUE INDEX INDEX_' + FAVORITE + '_shopId ON ' + FAVORITE + '(shopId)'
    }, callback);
};

function fnInsertFavorite(shopId, callback) {
    db.executeSql({
        name: DATABASE,
        sql: 'REPLACE INTO ' + FAVORITE + '(shopId) VALUES("' + shopId + '")'
    }, callback);
};

function fnSelectFavorite(callback) {
    db.selectSql({
        name: DATABASE,
        sql: 'SELECT id,shopId FROM ' + FAVORITE
    }, callback);
};
